package com.liang.dao;

import com.liang.entity.LayuiTree;
import com.liang.entity.SysPermissionInfo;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (SysPermissionInfo)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-19 21:37:38
 */
public interface SysPermissionInfoDao {

    /**
     * 通过ID查询单条数据
     *
     * @param permissionId 主键
     * @return 实例对象
     */
    SysPermissionInfo queryById(String permissionId);

    /**
     * 查询指定行数据
     *
     * @param sysPermissionInfo 查询条件
     * @param pageable          分页对象
     * @return 对象列表
     */
    List<SysPermissionInfo> queryAllByLimit(SysPermissionInfo sysPermissionInfo, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param sysPermissionInfo 查询条件
     * @return 总行数
     */
    long count(SysPermissionInfo sysPermissionInfo);

    /**
     * 新增数据
     *
     * @param sysPermissionInfo 实例对象
     * @return 影响行数
     */
    int insert(SysPermissionInfo sysPermissionInfo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysPermissionInfo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysPermissionInfo> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysPermissionInfo> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SysPermissionInfo> entities);

    /**
     * 修改数据
     *
     * @param sysPermissionInfo 实例对象
     * @return 影响行数
     */
    int update(SysPermissionInfo sysPermissionInfo);

    /**
     * 通过主键删除数据
     *
     * @param permissionId 主键
     * @return 影响行数
     */
    int deleteById(String permissionId);

    /**
     * 获取系统菜单
     *
     * @param userId
     * @return
     */
    List<Map> menuInit(int userId);

    /**
     * 查询菜单列表
     *
     * @return
     */
    List<SysPermissionInfo> list();

    /**
     * 获取权限列表
     *
     * @return
     */
    List<Map<String, Object>> listPermission();

    /**
     * 获取菜单列表(转化为LayuiTree对象)
     *
     * @return
     */
    List<LayuiTree> listTree();

    /**
     * 禁用一个菜单
     *
     * @param list
     * @return
     */
    int forbid(List<String> list);


    /**
     * 启用一个菜单
     *
     * @param list
     * @return
     */
    int enable(List<String> list);

    /**
     * 修改菜单顺序
     *
     * @param sysPermissionInfo
     * @return
     */
    int updateSort(SysPermissionInfo sysPermissionInfo);

    /**
     * 权限检查
     *
     * @param sign
     * @param userId
     * @return
     */
    int checkPermission(String sign, Integer userId);
}

